/*
 * packetmodeller/packet_modeller.h
 *
 * Copyright (C) 2008-2009 Reto Gantenbein
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

/**
 * PacketModeller - Traffic redirection deamon for vifd
 */

#ifndef __PACKETMODELLER_H
#define __PACKETMODELLER_H

/** INCLUDES ******************************************************************/
#include <errno.h>
#include <pthread.h>
#include <signal.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <syslog.h>
#include <unistd.h>
#include <netinet/in.h>
#include "pm_types.h"


/** PM TYPES ******************************************************************/

/** IPC message queue message format */
typedef struct pm_msg {
    long mtype;
    int vif_index;
    int property;
} pm_msg;


/** PM VALUES *****************************************************************/

/** Number of virtual interfaces that can be handled */
#define MAX_NUM_VIF         1

/** IPC key for communication with vifd */
#define IPC_KEY             1337

/** Message types */
#define PM_UPDATE           3   // update request for packetmodeller
#define PM_ACK              4   // response to update request

/** Maximum function */
#define max(a, b) ((a) > (b) ? (a) : (b))


/** PM VARIABLES **************************************************************/

/** Program name */
char *exec_name;

/** Number of virtual wireless interfaces */
int
num_vif;

/** Vif configuration list */
struct pm_vif_info
vif_list[MAX_NUM_VIF];

/** Node parameters */
char host_name[HOST_NAME_MAX];
host_id node_id;
char node_pif[IFNAMSIZ];
mac_addr node_pmac;

struct in_addr node_ip;
uint16_t node_port;

/** Model parameters */
struct sockaddr_in model_addr;

/** File descriptors */
int tap_fd;
int net_socket;
int fm;

/** Indicate direct node to node mode */
int direct;

/** Shared memory identifier */
int shmem_id;

#endif
