/*
 * vifd/vifd_print.h
 *
 * Copyright (C) 2009 Reto Gantenbein
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef __VIFD_PRINT_H
#define __VIFD_PRINT_H

/**
 * Header to include vifd_-printing functions (defined in vifd.c)
 */

#include <stdarg.h>


/** PUBLIC PRINT FUNCTIONS ****************************************************/

/** Debug function pointers */
int (*vifd_debug)(const char* format, ...);
void (*vifd_debug_args)(const char* format, va_list args);

/** Print Error message (with errno > 0) */
void
vifd_error(const char *, ...);

/** Send message to syslog */
void
vifd_log(const char *, ...);

#endif
