/*
 * wlanmodel/packetproxy.h
 *
 * Copyright (C) 2008-2009 Reto Gantenbein
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef __PACKETPROXY_H__
#define __PACKETPROXY_H__

#include <cstdlib>
#include <string>
#include <omnetpp.h>
#include <arpa/inet.h>
#include "crawsocketrtscheduler.h"
#include "message.h"
#include "nodeinfo.h"
#include "rawetherframe_m.h"

/**
 * Class responsible to distribute packets to simulated hosts representations
 */
class PacketProxy : public cSimpleModule
{
    private:
        cMessage *rtEvent;
        cRAWSocketRTScheduler *rtScheduler;
        cOutVector pktProcTime;

        //buffer
        char inBuffer[WLAN_MSG_SIZE];
        int numRecvBytes;

    protected:
        virtual void initialize();

        //message processing
        virtual void handleMessage(cMessage *msg);
        void handleSocketEvent(cMessage *rtMsg);
        void handleReply(RAWEtherFrame *pkt);

        void processNodeMsg(cMessage *rtMsg);
        void sendPacket(cMessage *msg);
        void registerNode(cMessage *rtMsg);
        int sendAcknowledgeMsg(uint16_t msg_id, NodeInfo *node);

    public:
        PacketProxy();
        virtual ~PacketProxy();
        static uint8_t getMessageType(msg_header *header);
        MACAddress getDestMacAddr(RAWEtherFrame *msg);
};

#endif
